package HashTree;
use strict;

#==================================================
sub new {
   my ($class, $data) = @_;
   my $self  = {};
   if(defined $data && ref($data) =~ /HASH/) {
      $self = $data;
   }
   bless $self, $class;
   return $self;
}

#==================================================
sub findTreeNode {
   my ( $tree, $key ) = @_;
   if ( exists $tree->{$key} ) {
      return $tree->{$key};
   }
   foreach my $subtree ( values( %{$tree} ) ) {
      my $node = findTreeNode( $subtree, $key );
      if ( defined $node ) {
         return $node;
      }
   }
   return undef;
}

#==================================================
sub insertTreeNode {
   my ( $tree, $nodeid, $supanodeid ) = @_;
   #my $node = $tree->findTreeNode($nodeid);
   #if ( defined $node ) {
   #   warn "WARNING: Attempt to insert $nodeid more than once.";
   #   return $tree;
   #}
   my $supanode = $tree->findTreeNode($supanodeid);
   if ( defined $supanode ) {
      $supanode->{$nodeid} = {};
   }
   else {
      if ( $nodeid eq $supanodeid ) {
         if ( %$tree == 0 ) {
            $supanode = $tree->{$supanodeid} = {};
            return $tree;
         }
      }
      warn
"ERROR: Supernode $supanodeid has to be inserted before inserting $nodeid";
   }
   return $tree;
}

#==================================================
sub printTree {
   my ( $tree, $FILE, $spacer ) = @_;
   if ( !defined $spacer ) {
      $spacer = '';
   }
   foreach my $key ( keys( %{$tree} ) ) {
      print $FILE "$spacer$key\n";
      printTree( $tree->{$key}, $FILE, $spacer . '   ' );
   }
}

#==================================================
sub printTreeFileToDepth {
   my ( $tree, $head, $FILE, $depth ) = @_;
   if ( $depth > 0 ) {
      foreach my $key ( keys( %{$tree} ) ) {
         print $FILE "$key\t$head\n";
         printTreeFileToDepth( $tree->{$key}, $key, $FILE, $depth-1 );
      }
   }
}
1;
